#include <stdio.h>
#include <dos.h>
#include <process.h>

#define maxDimension 3

// globale variablen

int dimension = 3 ;

int zeile = 0 ;
int spalte = 0 ;
int aktSpalte = 0 ;

int nachRechts = 0 ;

float koeffizient [3] [3] ;

double faktor = 1.0 ;

double x [ 3 ] ;
double b [ 3 ] ;

int main () 
{

// eingabe des LGS


for ( zeile = 0 ; zeile < dimension ; zeile ++ ) 
{
	for ( spalte = 0 ; spalte < dimension; spalte ++ ) 
	{
		printf ("Bitte geben Sie koeffizient[%i][%i] ein: " , zeile + 1 , spalte + 1 ) ;
		scanf ( "%f" , &koeffizient [zeile] [spalte] ) ;
	
	}	
	
	printf ("Bitte geben Sie b[%i] ein: " , zeile ) ;
	scanf ( "%lf" , &b [zeile] ) ;
}

system ( "cls" ) ;

// gleichungssystem ausgeben

for ( zeile = 0 ; zeile < dimension; zeile ++ ) 
{
	for ( spalte = 0 ; spalte < dimension; spalte ++ ) 
	{
		printf ("\t") ;
		printf ("%f X%i" , koeffizient [ zeile ] [ spalte ] , spalte ) ;
	}
		
	printf ("\t=\t") ;
	printf ("%.3f" , b [ zeile ] ) ;
	printf ( "\n" ) ;
}


printf ( "\n\n" ) ;

// gleichungssystem in dreiecksform bringen - elimination

for ( zeile = 0 ; zeile < dimension ; zeile ++ ) 
{
	// elimination beginnt rechts der diagonale

	for ( nachRechts = zeile + 1 ; nachRechts < dimension ; nachRechts ++ ) 
	{
		// Faktor ermitteln 

		faktor = koeffizient [ nachRechts ] [ zeile ] / koeffizient [ zeile ] [ zeile ] ;
        printf("%\n\tfaktor =  %.3f\n", faktor ) ;

		// koeffizienten in der Zeile nach rechts durch 'faktor' dividieren

		for ( aktSpalte = zeile ; aktSpalte < dimension ; aktSpalte ++ )
		{
			koeffizient  [ nachRechts ] [ aktSpalte ] = (float) ( koeffizient [nachRechts] [aktSpalte] - faktor * koeffizient [ zeile ][ aktSpalte] ) ;

			// wenn der aktuelle wert der diagonale 0 ist, ist das LGS unloesbar

			if ( koeffizient  [ zeile ][ zeile ] == 0.0) 
			{	
				printf ( "\nDas LGS ist unloesbar\n" );
				return 0 ;
			}
			
		}
			
		// b-Werte berechnen

	//	b [ nachRechts ] = b [ nachRechts ] - faktor * b [ zeile ] ;

		b [ nachRechts ] = b [ nachRechts ] - faktor * b [ zeile ] ;


		// gleichungssystem ausgeben

		printf ( "\n\n" ) ;

		for ( int i = 0 ; i < dimension; i ++ ) 
		{
			for ( int j = 0 ; j < dimension; j ++ ) 
			{
				printf ("\t") ;
				printf ("%.3f X%i" , koeffizient [ i ] [ j ] , j ) ;
			}
				
			printf ("\t=\t") ;
			printf ("%.3f" , b [ i ] ) ;
			printf ( "\n" ) ;
		}

	}
}



// x[i] rcksubstituieren

printf ( "\n\n" ) ;


for ( zeile = dimension - 1 ; zeile >= 0 ; zeile -- ) 
{


	for ( spalte = zeile  ; spalte < dimension ; spalte ++ ) 
	{
		b [ zeile ] = b [ zeile ] - x [ spalte ] * koeffizient [ zeile ] [ spalte ] ;
	}

	x [ zeile ] = b [ zeile ] / koeffizient [ zeile ] [ zeile ] ;

}


// ausgabe des loesungsvektors

printf ( "\n\n\tLoesungsvektor\n\n" ) ;

for ( zeile = 0 ; zeile < dimension; zeile ++ ) 
{
		printf ("\tX[%i] = %.3f\n" , zeile + 1, x [ zeile ] ) ;
}

return 0 ;

}